#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <math.h>

void fm_op(uint8_t* insdat,char* title)
{
    uint8_t dt1 = (insdat[0x04]>>4)&7;
    uint8_t mul = insdat[0x04]&15;
    uint8_t tl  = insdat[0x08]&127;
    uint8_t ks  = insdat[0x0c]>>6;
    uint8_t ar  = insdat[0x0c]&31;
    uint8_t ase = insdat[0x10]>>7;
    uint8_t d1r = insdat[0x10]&31;
    uint8_t dt2 = insdat[0x14]>>6;
    uint8_t d2r = insdat[0x14]&15;
    uint8_t d1l = insdat[0x18]>>4;
    uint8_t rr  = insdat[0x18]&15;
	
	printf("%s:%3d %3d %3d %3d %3d %3d %3d %3d %3d %3d %3d\n",
		title,ar,d1r,d2r,rr,d1l,tl,ks,mul,dt1,dt2,ase);

    return;
}

void fm_info(uint8_t* insdat)
{
	uint8_t con = insdat[0]&7;
    uint8_t fb = (insdat[0]>>3)&7;
    uint8_t pms = (insdat[3]>>4)&7;
	uint8_t ams = insdat[3]&3;
	
	printf("LFO:%3d %3d %3d %3d %3d\n",0,0,0,0,0,0);
	printf("CH:%3d %3d %3d %3d %3d %3d %3d\n",192,fb,con,ams,pms,120,0);

    fm_op(insdat,"M1");
    fm_op(insdat+2,"C1");
    fm_op(insdat+1,"M2");
    fm_op(insdat+3,"C2");
}

int main(int argc, char* argv [])
{
    int offset = 0;
	int count = 128;
    int i;

    if(argc<3)
        return;

    offset = (int)strtoul(argv[2],NULL,0);

    FILE* sourcefile;
    sourcefile = fopen(argv[1],"rb");

    if(!sourcefile)
    {
        printf("Could not open %s\n",argv[1]);
        perror("Error");
        exit(EXIT_FAILURE);
    }
    fseek(sourcefile,0,SEEK_END);
    long sourcefile_size = ftell(sourcefile);
    rewind(sourcefile);
    uint8_t* source = (uint8_t*)malloc(sourcefile_size);
    int res;
    res = fread(source,1,sourcefile_size,sourcefile);
    if(res != sourcefile_size)
    {
        printf("Reading error\n");
        exit(EXIT_FAILURE);
    }
	
	printf("//MiOPMdrv sound bank Paramer Ver2002.04.22 \n");
	printf("//LFO: LFRQ AMD PMD WF NFRQ\n");
	printf("//@:[Num] [Name]\n");
	printf("//CH: PAN	FL CON AMS PMS SLOT NE\n");
	printf("//[OPname]: AR D1R D2R	RR D1L	TL	KS MUL DT1 DT2 AMS-EN\n");

	for(i=0;i<count;i++)
	{
		printf("\n@:%d ins %d at 0x%04x\n",i,i,offset);
		
		fm_info(source+offset);
		offset += 32;
	}

    free(source);
}
